import pygame
import os
os.environ['SDL_VIDEO_WINDOW_POS'] = "%d,%d" %(8,30)
pygame.init()
from pygame.locals import *
import display
import arrays
import path
import map
import pdb
running = True
clock = pygame.time.Clock()
BN = 1000000
#terr = arrays.create(21,16,5)
#hex = (2,4)
#goal = (9,7)
hex = (2,1)
#goal = (15,4)
goal = (16,1)
#terr = path.eval_terrain(hex,goal)
#route = [map.hex_to_pix(hex)]
#next = hex
selections = 0
route = [0]
#while next != goal:
#    next = path.next(next,terr)
#    route += [map.hex_to_pix(next)]
print "Click on two successive tiles to start a solution"
print "To turn on search visualization, type v first."
while running:
    display.Clear()
    display.Update()
    if len(route)>1:
        (x,y) = map.hex_to_pix((hex))
        pygame.draw.circle(display.screen,(0,0,0),(x,y),5,0)
        (x,y) = map.hex_to_pix((goal))
        rect2 = pygame.Rect(x-5,y-5,10,10)
        pygame.draw.rect(display.screen,(0,0,0),rect2,0)

        pygame.draw.lines(display.screen,(16,16,16),False,route,3)
    display.Flip()
    clock.tick(5)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        elif event.type == MOUSEBUTTONDOWN:
            pos = pygame.mouse.get_pos()
            print "pos=",pos,"hex = ",map.pix_to_hex(pos)
            selections = selections + 1
            if selections == 1 :
                hex = map.pix_to_hex(pos)
                goal = hex
                route = [hex]
            if selections == 2 :
                goal = map.pix_to_hex(pos)
            if goal != hex :
                next = hex
                terr = path.eval_terrain(hex,goal)
                route = [map.hex_to_pix(hex)]
                while next != goal:
                    next = path.next(next,terr)
                    route += [map.hex_to_pix(next)]
                selections = 0
                
        elif event.type == KEYDOWN:
            if event.key == K_ESCAPE:
                running = False
            if event.key == K_v:
                if path.visual == False:
                    path.visual = True
                else :
                    path.visual = False
                selections = 0
#                pdb.set_trace()
print "Iterations = ",path.iterations                
            
