import math
import pygame
nrows = 21
ncols = 16
hw = 64
hh = 48
dx = hw
dy = hh/2+hh/4
dxh = dx/2
dyh = dy/2
#print "Map:"
#print "dx = ",dx,"dy = dy","dxh =  ",dxh,"dyh = ",dyh
# compute pixel coordinates from hex
# r,c = row and column, x,y = center of hex in pixels
terrain = pygame.image.load("png/terrain.png")
def hex_to_pix((r,c)):
    x = c*dx+(r%2)*dxh+dxh
#   x = int(c*dx)+dxh
    y = r*dy+hh/2
#    print 'x,y = ',x,y
    return (x,y)
# compute hex coordinates from mouse (x,y)
def pix_to_hex((x,y)):
    r = int(y/dy)
    c = int((x-(r%2)*dxh)/dx)
#    print 'r,c = ',r,c
    return (r,c)
def terrain_type((r,c)):
    (x,y) = hex_to_pix((r,c))
#    print (r,c),(x,y)
    if r < 0 :
        clr = (0,0,128,255)
    elif c >= ncols:
        clr = (0,0,128,255)
    elif r >= nrows:
        clr = (0,0,128,255)
    elif c < 0 :
        clr = (0,0,128,255)
    else :
#        print 'map 40 ',(r,c),(x,y)
        clr = terrain.get_at((x,y))
    return clr
def onmap((r,c)):
    if r < 0 :
        return False
    elif r >= nrows :
        return False
    elif c < 0:
        return False
    elif c >= ncols :
        return False
    return True
    
